// GetRxCounters.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <TlHelp32.h>
#include "mxprp.h"

bool CheckMxPrpService();
unsigned short ReverseBytes(unsigned short value);
unsigned int GetRxGoodOctets(UINT8 slaveAddr, UINT8 portSel);
unsigned int GetRxErrOctets(UINT8 slaveAddr, UINT8 portSel);
unsigned int GetRxWrongLan(UINT8 slaveAddr, UINT8 portSel);
unsigned int GetRxDuplicate(UINT8 slaveAddr, UINT8 portSel);

/*****************************************************************/
int _tmain(int argc, _TCHAR* argv[])
{
	UINT8 portSel = 0;
	UINT8 funcSel = 0;
	unsigned short counterOffset = 0;
	unsigned int rxCounter = 0x0;
	int boardIndex = 0;
	UINT8 slaveAddr = 0x0;
	bool isServiceExist = false; 

	isServiceExist = CheckMxPrpService();
	if(isServiceExist==true)
	{
		printf("mxPrpService is running, to run this program, please stop the mxPrpService\n");
		printf("Exit the program\n");
		return 0;
	}

	

	/* Get user selection for smbus slave address */
	printf("Enter the boardIndex:\n");
	scanf("%d", &boardIndex);
	slaveAddr = SMBUS_SLAVE_ADDRESS;
	slaveAddr += boardIndex;

	/* Configure Counter Control bit to 1 to update the values in counter registers */
	printf("Select Port to configure: 2: Port0, 4: Port1, 8: Port2\n");
	scanf("%d", &portSel);
	printf("portSel = %d\n", portSel);
	
	/* Get the counter value */
	printf("Select counter value to get:\n \
										 0: RX GOOD OCTETS\n \
										 1: RX ERR\n \
										 2: RX WRONGLAN\n \
										 3: RX DUPLICATE\n \
										 \n");
	scanf("%d", &funcSel);

	switch(funcSel)
	{
	case 0:
		rxCounter = GetRxGoodOctets(slaveAddr, portSel);
		break;
	case 1:
		rxCounter = GetRxErrOctets(slaveAddr, portSel);
		break;
	case 2:
		rxCounter = GetRxWrongLan(slaveAddr, portSel);
		break;
	case 3:
		rxCounter = GetRxDuplicate(slaveAddr, portSel);
		break;

	default:
		break;
		
	}
	
	printf("rxCounter = 0x%x\n", rxCounter);
	
	return 0;
}

unsigned int GetRxGoodOctets(UINT8 slaveAddr, UINT8 portSel)
{
	unsigned int rxCount = 0;
	unsigned short rxCountLow = 0;
	unsigned short rxCountHigh = 0;
	unsigned short recvData = 0x0;

	 /* Get low part of RX counter */
    GetRxCounter(slaveAddr, portSel, (short)CNT_CFG_REG_OFFSET_RX_GOOD_OCTETS_L, &recvData);
    rxCountLow = ReverseBytes(recvData);

    /* Get high part of RX counter */
    GetRxCounter(slaveAddr, portSel, (short)CNT_CFG_REG_OFFSET_RX_GOOD_OCTETS_H, &recvData);
    rxCountHigh = ReverseBytes(recvData);

    /* Combine low part and high part data */
    rxCount = (unsigned int)(rxCountHigh << 16) + rxCountLow;

	return rxCount;
}

unsigned int GetRxErrOctets(UINT8 slaveAddr, UINT8 portSel)
{
	unsigned int rxCount = 0;
	unsigned short rxCountLow = 0;
	unsigned short rxCountHigh = 0;
	unsigned short recvData = 0x0;

	 /* Get low part of RX counter */
    GetRxCounter(slaveAddr, portSel, (short)CNT_CFG_REG_OFFSET_RX_ERR_L, &recvData);
    rxCountLow = ReverseBytes(recvData);

    /* Get high part of RX counter */
    GetRxCounter(slaveAddr, portSel, (short)CNT_CFG_REG_OFFSET_RX_ERR_H, &recvData);
    rxCountHigh = ReverseBytes(recvData);

    /* Combine low part and high part data */
    rxCount = (unsigned int)(rxCountHigh << 16) + rxCountLow;

	return rxCount;
}

unsigned int GetRxWrongLan(UINT8 slaveAddr, UINT8 portSel)
{
	unsigned int rxCount = 0;
	unsigned short rxCountLow = 0;
	unsigned short rxCountHigh = 0;
	unsigned short recvData = 0x0;

	 /* Get low part of RX counter */
    GetRxCounter(slaveAddr, portSel, (short)CNT_CFG_REG_OFFSET_RX_WRONGLAN_L, &recvData);
    rxCountLow = ReverseBytes(recvData);

    /* Get high part of RX counter */
    GetRxCounter(slaveAddr, portSel, (short)CNT_CFG_REG_OFFSET_RX_WRONGLAN_H, &recvData);
    rxCountHigh = ReverseBytes(recvData);

    /* Combine low part and high part data */
    rxCount = (unsigned int)(rxCountHigh << 16) + rxCountLow;

	return rxCount;
}

unsigned int GetRxDuplicate(UINT8 slaveAddr, UINT8 portSel)
{
	unsigned int rxCount = 0;
	unsigned short rxCountLow = 0;
	unsigned short rxCountHigh = 0;
	unsigned short recvData = 0x0;

	 /* Get low part of RX counter */
    GetRxCounter(slaveAddr, portSel, (short)CNT_CFG_REG_OFFSET_RX_DUPLICATE_L, &recvData);
    rxCountLow = ReverseBytes(recvData);

    /* Get high part of RX counter */
    GetRxCounter(slaveAddr, portSel, (short)CNT_CFG_REG_OFFSET_RX_DUPLICATE_H, &recvData);
    rxCountHigh = ReverseBytes(recvData);

    /* Combine low part and high part data */
    rxCount = (unsigned int)(rxCountHigh << 16) + rxCountLow;

	return rxCount;
}

unsigned short ReverseBytes(unsigned short value)
{
    return (unsigned short)((value & 0xFFU) << 8 | (value & 0xFF00U) >> 8);
}

bool CheckMxPrpService()
{
	WCHAR* name = L"MxPrpSvc.exe";

	HANDLE SnapShot = CreateToolhelp32Snapshot( TH32CS_SNAPPROCESS, 0 );

	if( SnapShot == INVALID_HANDLE_VALUE )
		return false;

	PROCESSENTRY32 procEntry;
	procEntry.dwSize = sizeof( PROCESSENTRY32 );

	if( !Process32First( SnapShot, &procEntry ) )
		return false;

	do
	{
		//wprintf(L"%s\n", procEntry.szExeFile);
		if( _tcscmp( procEntry.szExeFile, name ) == 0 )
			return true;
	}
	while( Process32Next( SnapShot, &procEntry ) );

	return false;
}