//  GetTxCounters.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <TlHelp32.h>
#include "mxprp.h"

bool CheckMxPrpService();
unsigned short ReverseBytes(unsigned short value);
unsigned int GetTxOctets(UINT8 slaveAddr, UINT8 portSel);

/*****************************************************************/
int _tmain(int argc, _TCHAR* argv[])
{
	UINT8 portSel = 0;
	UINT8 funcSel = 0;
	unsigned short counterOffset = 0;
	unsigned int txCount;
	int boardIndex = 0;
	UINT8 slaveAddr = 0x0;
	bool isServiceExist = false; 

	isServiceExist = CheckMxPrpService();
	if(isServiceExist==true)
	{
		printf("mxPrpService is running, to run this program, please stop the mxPrpService\n");
		printf("Exit the program\n");
		return 0;
	}


	/* Get user selection for smbus slave address */
	printf("Enter the boardIndex:\n");
	scanf("%d", &boardIndex);
	slaveAddr = SMBUS_SLAVE_ADDRESS;
	slaveAddr += boardIndex;

	/* Configure Counter Control bit to 1 to update the values in counter registers */
	printf("Select Port to configure: 2: Port0, 4: Port1, 8: Port2");
	scanf("%d", &portSel);

	/* Get TX count */
	txCount =GetTxOctets(slaveAddr, portSel);
	printf("txCount = %d\n", txCount);

	return 0;
}

unsigned int GetTxOctets(UINT8 slaveAddr, UINT8 portSel)
{
	unsigned int txCount = 0;
	unsigned short txCountLow = 0;
	unsigned short txCountHigh = 0;
	unsigned short recvData = 0x0;

	 /* Get low part of TX counter */
    GetTxCounter(slaveAddr, portSel, (short)CNT_CFG_REG_OFFSET_TX_OCTETS_L, &recvData);
    txCountLow = ReverseBytes(recvData);

    /* Get high part of TX counter */
    GetTxCounter(slaveAddr, portSel, (short)CNT_CFG_REG_OFFSET_TX_OCTETS_H, &recvData);
    txCountHigh = ReverseBytes(recvData);

    /* Combine low part and high part data */
    txCount = (unsigned int)(txCountHigh << 16) + txCountLow;

	return txCount;
}

unsigned short ReverseBytes(unsigned short value)
{
    return (unsigned short)((value & 0xFFU) << 8 | (value & 0xFF00U) >> 8);
}

bool CheckMxPrpService()
{
	WCHAR* name = L"MxPrpSvc.exe";

	HANDLE SnapShot = CreateToolhelp32Snapshot( TH32CS_SNAPPROCESS, 0 );

	if( SnapShot == INVALID_HANDLE_VALUE )
		return false;

	PROCESSENTRY32 procEntry;
	procEntry.dwSize = sizeof( PROCESSENTRY32 );

	if( !Process32First( SnapShot, &procEntry ) )
		return false;

	do
	{
		if( _tcscmp( procEntry.szExeFile, name ) == 0 )
			return true;
	}
	while( Process32Next( SnapShot, &procEntry ) );

	return false;
}
