// QueryLinkStatus.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <TlHelp32.h>
#include "mxprp.h"

bool CheckMxPrpService();

int _tmain(int argc, _TCHAR* argv[])
{
	int boardIndex = 0;
	int linkStatusLanA = 0, linkStatusLanB = 0;
	UINT8 slaveAddr = SMBUS_SLAVE_ADDRESS;
	bool isServiceExist = false;

	isServiceExist = CheckMxPrpService();
	if (isServiceExist == true)
	{
		printf("mxPrpService is running, to run this program, please stop the mxPrpService\n");
		printf("Exit the program\n");
		return 0;
	}

	/* Get user selection for smbus slave address */
	printf("Enter the boardIndex:\n");
	scanf("%d", &boardIndex);
	slaveAddr = SMBUS_SLAVE_ADDRESS;
	slaveAddr += boardIndex;

	/* Get current Mode Control Register value */
	printf("Get mode control register of LanA...............................\n");
	linkStatusLanA = GetLinkStatus(slaveAddr, PHY_ADDR_LANA);
	printf("Link Status of LanA = 0x%x\n", linkStatusLanA);

	/* Get current Mode Control Register value */
	printf("Get mode control register of LanB...............................\n");
	linkStatusLanB = GetLinkStatus(slaveAddr, PHY_ADDR_LANB);
	printf("Link Status of LanB = 0x%x\n", linkStatusLanB);

	return 0;
}

bool CheckMxPrpService()
{
	WCHAR* name = L"MxPrpSvc.exe";

	HANDLE SnapShot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);

	if (SnapShot == INVALID_HANDLE_VALUE)
		return false;

	PROCESSENTRY32 procEntry;
	procEntry.dwSize = sizeof(PROCESSENTRY32);

	if (!Process32First(SnapShot, &procEntry))
		return false;

	do
	{
		//wprintf(L"%s\n", procEntry.szExeFile);
		if (_tcscmp(procEntry.szExeFile, name) == 0)
			return true;
	} while (Process32Next(SnapShot, &procEntry));

	return false;
}